using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

// For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WK_KLI_LAPS_Service.Controllers.Master.Customer
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class CustomerApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private ICustomerService _Customerservices;
        public CustomerApiController(ICustomerService CustomerServices)
        {
            _Customerservices = CustomerServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _Customerservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveCustomer")]
        //Code to retrieve active data
        public IActionResult GetActiveCustomer()
        {
            var _list = _Customerservices.GetActiveCustomer();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] customerModel ocustomerModel)
        {

            int retval = 0;
            try
            {
                retval = _Customerservices.Add(ocustomerModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] customerModel ocustomerModel)
        {
            int retval = 0;
            try
            {
                retval = _Customerservices.Edit(ocustomerModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] customerModel ocustomerModel)
        {
            int retval = 0;
            try
            {
                retval = _Customerservices.Delete(ocustomerModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}
